local s2 = sqrt(2)
local cos, sin, rad = math.cos, math.sin, math.rad
local temp
local UnitHealth, UnitPower = UnitHealth, UnitPower
local UnitHealthMax, UnitPowerMax = UnitHealthMax, UnitPowerMax
local RAID_CLASS_COLORS = RAID_CLASS_COLORS
local GetRuneType, GetRuneCooldown = GetRuneType, GetRuneCooldown
local anim = CreateFrame("Frame")
local fadeinframes = {}
local fadeoutframes = {}
local scaleframes = {}
hudpro = "default"



hudoptions = {
	["default"] = {
		["botblock"] = {
			"",
			"target",
			{1,1,1},
			1,
			{1,1,1},
			1,
			"",
			"target",
			{1,1,1},
			1,
			{1,1,1},
			1,
			"",
			"target",
			{1,1,1},
			1,
			{1,1,1},
			1,
		},
		["health"] = {
			0.4,
			{1,1,1},
			[9] = 1,
			[10] = 1,
			[11] = nil,
		},
		["leftbar"] = {
			1,
			"",
			"player",
			{1,1,1},
			1,
		},
		["botbar"] = {
			1,
			"",
			"player",
			{1,1,1},
			1,
		},
		["rightbar"] = {
			1,
			"",
			"player",
			{1,1,1},
			1,
		},
		["power"] = {
			0.4,
			{1,1,1},
			[9] = 1,
			[10] = 1,
		},
		["general"] = {
			1,
			1,
			0,
			0,
		},
		["buff"] = {
			1,
			1,
		},
		["target"]= {
			1,
			{1,1,1},
			nil,
			nil,
			1,
			{1,1,1},
			nil,
			nil,
			1,
			1,
		},
	},
}
hudwipetable = hudoptions


local rc = { --rune colors
{r=1, g=0.3, b=0.3}, --blood
{r=0.77, g=1, b=0.55}, --unholy
{r=0, g=0.8, b=1}, --frost
{r=0.77, g=0, b=1}, --death
}

 local UnitReactionColor = {
	{ r = 1.0, g = 0.7, b = 0.7 },
	{ r = 1.0, g = 0.7, b = 0.7 },
	{ r = 1.0, g = 0, b = 0.0 },
	{ r = 1.0, g = 1.0, b = 0.0 },
	{ r = 0.0, g = 1.0, b = 0.0 },
	{ r = 0.0, g = 1.0, b = 0.0 },
	{ r = 0.0, g = 1.0, b = 0.0 },
	{ r = 0.0, g = 1.0, b = 0.0 },
}

local function CC(ang)
	local r = rad(ang)
	return 0.5 + cos(r) / s2, 0.5 + sin(r) / s2
end
local function RT(texture, angle)
	local LRx, LRy = CC(angle + 45)
	local LLx, LLy = CC(angle + 135)
	local ULx, ULy = CC(angle + 225)
	local URx, URy = CC(angle - 45)
	
	texture:SetTexCoord(ULx, ULy, LLx, LLy, URx, URy, LRx, LRy)
end


 local function animate(_, e)
	for _, frame in pairs(fadeinframes) do
		--[[if ( frame.maxAlpha ) and ( frame:GetAlpha()-(e*4) >= frame.maxAlpha )then
			frame:SetAlpha(frame.maxAlpha)
			tDeleteItem(fadeinframes, frame)
		else]]if frame:GetAlpha()+(e*4) >= 1 then 
		frame:SetAlpha(1)
		tDeleteItem(fadeinframes, frame)
		else
			frame:SetAlpha(frame:GetAlpha()+(e*4))
		end
	end
	for _, frame in pairs(fadeoutframes) do
		if ( frame.minAlpha ) and ( frame:GetAlpha()-(e*4) <= frame.minAlpha )then
			frame:SetAlpha(frame.minAlpha)
			tDeleteItem(fadeoutframes, frame)
		elseif frame:GetAlpha()-(e*4) <= 0 then 
			frame:SetAlpha(0)
			tDeleteItem(fadeoutframes, frame)
			frame:Hide()
		else
			frame:SetAlpha(frame:GetAlpha()-(e*4))
		end
	end
	for _, frame in pairs(scaleframes) do
		if frame.tarScale > frame:GetScale() then
			if frame:GetScale()+(e*2) >= frame.tarScale then 
				frame:SetScale(frame.tarScale)
				tDeleteItem(scaleframes, frame)
			else
				frame:SetScale(frame:GetScale()+(e*2))
			end
		elseif frame.tarScale < frame:GetScale() then
			if frame:GetScale()-(e*2) <= frame.tarScale then 
				frame:SetScale(frame.tarScale)
				tDeleteItem(scaleframes, frame)
			else
				frame:SetScale(frame:GetScale()-(e*2))
			end
		else
			tDeleteItem(scaleframes, frame)
		end
	end
end
anim:SetScript("OnUpdate", animate)

local function fadeIn(frame)
	tDeleteItem(fadeoutframes, frame)
	tinsert(fadeinframes, frame)
end

local function fadeOut(frame)
	tDeleteItem(fadeinframes, frame)
	tinsert(fadeoutframes, frame)
end

local function rotUpdate(self, e)
	if (self.r+(e*14*self.d))*self.d > self.rotation*self.d then self:SetScript("OnUpdate", nil) RT(self.texture, self.rotation) return end
	self.r = self.r+(e*14*self.d)
	RT(self.texture, self.r)
end

local function rotate(self, d)
	self.d = d
	self.r = self.rotation-(5*d)
	RT(self.texture, self.rotation+(5*d))
	self:SetScript("OnUpdate", rotUpdate)
end

local function Dimension(frame, w, h)
	frame:SetWidth(w or 512) frame:SetHeight(h or w or 512)
end

local formatText = {}
formatText[1] = function(frame, c, m)

	if frame.short and c > frame.short then
		return (floor(c/100)/10).."k"
	else
		return c
	end
end
formatText[2] = function(frame, c, m)
	if frame.short and c > frame.short then
		c = (floor(c/100)/10).."k"
	end
	if frame.short and m > frame.short then
		m = (floor(m/100)/10).."k"
	end
	return c.."/"..m
end
formatText[3] = function(frame, c, m)
	local p = floor(100*c/m)
	if frame.short and c > frame.short then
		c = (floor(c/100)/10).."k"
	end
	return c.." "..p.."%"
end
formatText[4] = function(frame, c, m)
	local p = floor(100*c/m)
	if frame.short and c > frame.short then
		c = (floor(c/100)/10).."k"
	end
	if frame.short and m > frame.short then
		m = (floor(m/100)/10).."k"
	end
	return c.."/"..m.." "..p.."%"
end

formatText[5] = function(frame, c, m)
	return floor(100*c/m).."%"	
end

local function updatePP(self, event, unit)
	if unit ~= self.unit and ( event~= "PLAYER_ENTERING_WORLD" ) then return end
	local c = UnitPower(self.unit)
	local m = UnitPowerMax(self.unit)
	if UnitExists(self.unit) then
		temp = c/m
		temp = floor(temp*20)
	else
		temp = 0
	end
	self:UpdateText(c, m)
	for i=1, 20 do
		if i <= temp then
			if not self[i]:IsShown() then
				self[i]:Show()
				rotate(self[i], 1)
				fadeIn(self[i])
			end
		else
			if self[i]:IsShown() then
				fadeOut(self[i])
			end
		end
	end
end

local function updateHP(self, event, unit)
	if unit ~= self.unit and ( event== "UNIT_HEALTH" or event== "UNIT_MAXHEALTH" ) then return end
	local c = UnitHealth(self.unit)
	local m = UnitHealthMax(self.unit)
	if UnitExists(self.unit) then
		temp = c/m
		temp = floor(temp*20)
	else
		temp = 0
	end
	self:UpdateText(c, m)
	for i=1, 20 do
		if i <= temp then
			if not self[i]:IsShown() then
				self[i]:Show()
				rotate(self[i], -1)
				fadeIn(self[i])
			end
		else
			if self[i]:IsShown() then
				fadeOut(self[i])
			end
		end
	end
end

local function updaterune(self, e)
	local start, duration, runeReady = GetRuneCooldown(self:GetID());
	if runeReady then
		--self:Show()
		self:SetScript("OnUpdate", nil)
		self:SetAlpha(0)
		self:SetScale(1.5)
		fadeIn(self)
		tinsert(scaleframes, self)
		self.text:SetText(nil)
	else
		self.text:SetText(ceil(duration- (GetTime() - start)));
	end
end;

local fadehpf, fadempf, fadempe, fadenc, fadent = 1,1,1,1,1
local fadeframe = CreateFrame("Frame")
fadeframe:SetPoint("CENTER",0,0)
Dimension(fadeframe)

local parent = CreateFrame("Frame", nil, fadeframe)
parent:SetPoint("CENTER",0,0)
Dimension(parent)

local fontframe = CreateFrame("Frame", nil, parent)
Dimension(fontframe)
fontframe:SetPoint("CENTER",0,0)

local eframe = CreateFrame("Frame", nil, parent)
Dimension(eframe)
eframe:SetPoint("CENTER",0,0)

local frame = CreateFrame("Frame", nil, parent)
Dimension(frame)
frame:SetPoint("CENTER",0,0)
frame:SetAlpha(0.2)
frame.minAlpha = 0.2
local topbar = CreateFrame("Frame", nil, parent)
topbar:Hide()
local playerHealth = CreateFrame("Frame", nil, parent)
Dimension(playerHealth)
playerHealth:SetPoint("CENTER",0,0)
playerHealth:SetAlpha(0.4)
local playerPower = CreateFrame("Frame", nil, parent)
Dimension(playerPower)
playerPower:SetPoint("CENTER",0,0)
playerPower:SetAlpha(0.4)
local targetHealth = CreateFrame("Frame", nil, parent)
Dimension(targetHealth)
targetHealth:SetPoint("CENTER",0,0)
targetHealth:SetAlpha(0.8)
for i=1, 20 do
	playerHealth[i] = CreateFrame("Frame", nil, playerHealth)
	Dimension(playerHealth[i])
	playerHealth[i]:SetPoint("CENTER",0,0)
	--playerHealth[i]:SetScale(0.1*i);
	playerHealth[i].texture = playerHealth[i]:CreateTexture(nil, "BACKGROUND")
	Dimension(playerHealth[i].texture)
	playerHealth[i].texture:SetPoint("CENTER",0,0)
	playerHealth[i].texture:SetTexture("Interface\\AddOns\\hud\\bar.tga")
	playerHealth[i].rotation = -(31+((i-1)*4.5))
	RT(playerHealth[i].texture, playerHealth[i].rotation)
	--playerHealth[i]:SetAlpha(0.9-i*0.04);
	
	playerPower[i] = CreateFrame("Frame", nil, playerPower)
	Dimension(playerPower[i])
	playerPower[i]:SetPoint("CENTER",0,0)
	--playerPower[i]:SetScale(2.1-0.1*i);
	playerPower[i].texture = playerPower[i]:CreateTexture(nil, "BACKGROUND")
	Dimension(playerPower[i].texture, 509, 512)
	playerPower[i].texture:SetPoint("CENTER",0,0)
	playerPower[i].texture:SetTexture("Interface\\AddOns\\hud\\bar.tga")
	playerPower[i].rotation = (31.5+((i-1)*4.5))
	RT(playerPower[i].texture, playerPower[i].rotation)
	playerPower[i]:Hide()
	
	targetHealth[i] = CreateFrame("Frame", nil, targetHealth)
	Dimension(targetHealth[i])
	targetHealth[i]:SetPoint("CENTER",0,0)
	--targetHealth[i]:SetScale(0.1*i);
	targetHealth[i].texture = targetHealth[i]:CreateTexture(nil, "BACKGROUND")
	Dimension(targetHealth[i].texture)
	targetHealth[i].texture:SetPoint("CENTER",0,-1)
	targetHealth[i].texture:SetTexture("Interface\\AddOns\\hud\\bar.tga")
	targetHealth[i].rotation = -(137+((i-1)*4.5))
	RT(targetHealth[i].texture, targetHealth[i].rotation)

end

playerHealth.unit = "player"
playerPower.unit = "player"
targetHealth.unit = "target"
--playerHealth.textStyle = 1
local function dowefade()
	if fadehpf and (UnitHealth(playerHealth.unit)~=UnitHealthMax(playerHealth.unit)) then return 1 end

	if fadempf and (UnitPower(playerHealth.unit)~=UnitPowerMax(playerHealth.unit)) then return 1 end

	if fadempe and (UnitPower(playerHealth.unit)~=0) then return 1 end

	if fadenc and UnitAffectingCombat(playerHealth.unit) then return 1 end

	if fadent and UnitExists(targetHealth.unit) then return 1 end
	return nil
end
local function fadefunc(self)
	if dowefade() then
		self:Show()
		fadeIn(self)
	else
		fadeOut(self)
	end
end
fadeframe:RegisterEvent("PLAYER_ENTERING_WORLD")
fadeframe:RegisterEvent("PLAYER_REGEN_ENABLED")
fadeframe:RegisterEvent("UNIT_HEALTH")
fadeframe:RegisterEvent("UNIT_MANA")
fadeframe:RegisterEvent("UNIT_MAXMANA")
fadeframe:RegisterEvent("UNIT_ENERGY")
fadeframe:RegisterEvent("UNIT_MAXENERGY")
fadeframe:RegisterEvent("UNIT_RAGE")
fadeframe:RegisterEvent("UNIT_MAXRAGE")
fadeframe:RegisterEvent("UNIT_RUNIC_POWER")
fadeframe:RegisterEvent("UNIT_MAXRUNIC_POWER")
fadeframe:RegisterEvent("PLAYER_REGEN_DISABLED")
fadeframe:RegisterEvent("PLAYER_TARGET_CHANGED")

function playerHealth.UpdateText(self, c, m)
	if self.text:IsShown() then
		if self.hideFull and c == m then
			self.text:SetText(nil)
		else
			self.text:SetText(formatText[self.textStyle](self, c, m))
		end
	end
end

playerHealth:SetScript("OnEvent", updateHP)
playerHealth:RegisterEvent("UNIT_HEALTH")
playerHealth:RegisterEvent("UNIT_MAXHEALTH")
playerHealth:RegisterEvent("PLAYER_ENTERING_WORLD")

function targetHealth.UpdateText(self, c, m)
	if self.text:IsShown() then
		if ( self.hideFull and c == m ) or c == 0 then
			self.text:SetText(nil)
		else
			self.text:SetText(formatText[self.textStyle](self, c, m))
		end
	end
end
targetHealth.UNIT_HEALTH = updateHP
targetHealth.UNIT_MAXHEALTH = updateHP

local clatarhp, hostarhp, powtarpp, clatarpp, coltarhp, coltarpp
targetHealth.PLAYER_TARGET_CHANGED = function(self)
	updateHP(self, "", self.unit)
	if not UnitExists(self.unit) then return end
	if clatarhp and UnitIsPlayer(self.unit) then
		temp = select(2,UnitClass(self.unit))
		temp = RAID_CLASS_COLORS[temp]
		for i=1, 20 do
			targetHealth[i].texture:SetVertexColor(temp.r+0.2, temp.g+0.2, temp.b+0.2)
		end
	elseif hostarhp then
		temp = UnitReaction(self.unit, playerHealth.unit);
			if temp then
				temp = UnitReactionColor[temp]
				for i=1, 20 do
					targetHealth[i].texture:SetVertexColor(temp.r, temp.g, temp.b)
				end
			else
				for i=1, 20 do
					targetHealth[i].texture:SetVertexColor(unpack(coltarpp))
				end
			end
	else
		for i=1, 20 do
			targetHealth[i].texture:SetVertexColor(unpack(coltarhp))
		end
	end
	if clatarpp and UnitIsPlayer(self.unit) then
		temp = select(2,UnitClass(self.unit))
		temp = RAID_CLASS_COLORS[temp]
		topbar:SetStatusBarColor(temp.r+0.2, temp.g+0.2, temp.b+0.2)
	elseif powtarpp then
		temp = UnitPowerType(self.unit)
			if temp then
				temp = PowerBarColor[temp]
				topbar:SetStatusBarColor(temp.r+0.4, temp.g+0.4, temp.b+0.4)
			else
				topbar:SetStatusBarColor(unpack(coltarhp))
			end
	else
		topbar:SetStatusBarColor(unpack(coltarpp))
	end
end

targetHealth.UNIT_DISPLAYPOWER = function(self)
	if not UnitExists(self.unit) then return end
	if powtarpp then
		temp = UnitPowerType(self.unit)
		if temp then
			temp = PowerBarColor[temp]
			topbar:SetStatusBarColor(temp.r+0.4, temp.g+0.4, temp.b+0.4)
		else
			topbar:SetStatusBarColor(unpack(coltarhp))
		end
	end
end

targetHealth:SetScript("OnEvent", function(self, event, ...)
	self[event](self ,event ,...)
end)
targetHealth:RegisterEvent("UNIT_HEALTH")
targetHealth:RegisterEvent("UNIT_MAXHEALTH")
targetHealth:RegisterEvent("PLAYER_TARGET_CHANGED")
targetHealth:RegisterEvent("UNIT_DISPLAYPOWER")

playerPower.textStyle = 1

function playerPower.UpdateText(self, c, m)
	if self.text:IsShown() then
		if self.hideFull and c == m then
			self.text:SetText(nil)
		elseif self.hideEmpty and c == 0 then
			self.text:SetText(nil)
		else
			self.text:SetText(formatText[self.textStyle](self, c, m))
		end
	end
end

playerPower:SetScript("OnEvent", updatePP)
playerPower:RegisterEvent("UNIT_MANA")
playerPower:RegisterEvent("UNIT_MAXMANA")
playerPower:RegisterEvent("UNIT_ENERGY")
playerPower:RegisterEvent("UNIT_MAXENERGY")
playerPower:RegisterEvent("UNIT_RAGE")
playerPower:RegisterEvent("UNIT_MAXRAGE")
playerPower:RegisterEvent("UNIT_RUNIC_POWER")
playerPower:RegisterEvent("UNIT_MAXRUNIC_POWER")
playerPower:RegisterEvent("PLAYER_ENTERING_WORLD")



local ebar = {};
for i=1, 6 do
	ebar[i] = CreateFrame("Frame", nil, eframe)
	Dimension(ebar[i])
	ebar[i]:SetPoint("CENTER",0,0)
	--ebar[i]:SetScale(0.8+0.1*i);
	ebar[i].texture = ebar[i]:CreateTexture(nil, "BACKGROUND")
	Dimension(ebar[i].texture)
	ebar[i].texture:SetPoint("CENTER",0,0)
	ebar[i].texture:SetTexture("Interface\\AddOns\\hud\\rc.tga")
	ebar[i].rotation = (i-1)*15+0.5
	RT(ebar[i].texture, ebar[i].rotation)
	ebar[i].text = fontframe:CreateFontString(nil,"OVERLAY")
	ebar[i].text:SetFont("Fonts\\ARIALN.TTF", 12, "OUTLINE")
	ebar[i].text:SetPoint("CENTER", ebar[i], (158+i*0.1)*cos(rad(15*i-67.5)), (158+i*0.1)*sin(rad(15*i-67.5)));
	--ebar[i].text:SetPoint("LEFT",ebar[i], "CENTER" , 0, i*10)
	--ebar[i].text:SetText(i)
	ebar[i]:SetID(i)
	ebar[i].tarScale = 1
end
local extraOnEvent
if select(2,UnitClass("player")) == "DEATHKNIGHT" then
for i=1, 6 do
	ebar[i].minAlpha = 0.2
end
extraOnEvent = function(self, event, ...)
	if ( event == "PLAYER_ENTERING_WORLD" ) then
		for i=1, 6 do
			temp = rc[GetRuneType(i)];
			ebar[i].texture:SetVertexColor(temp.r, temp.g, temp.b)
		end
	elseif ( event == "RUNE_POWER_UPDATE" ) then
		local rune, usable = ...
		if ( not usable and rune ) then
			fadeOut(ebar[rune])
			ebar[rune]:SetScript("OnUpdate", updaterune)
			--runeFrame[rune].texture:SetAlpha(0.2);
		--[[elseif ( usable and rune ) then
			runeFrame[rune]:SetScript("OnUpdate", nil);
			runeFrame[rune].texture:SetAlpha(1);
			runeFrame[rune].text:SetText(nil);]]
		end
	elseif ( event == "RUNE_TYPE_UPDATE" ) then
		local rune = ...
		if rune then
			--ChatFrame1:AddMessage(rune..", "..GetRuneType(rune))
			temp = rc[GetRuneType(rune)]
			ebar[rune].texture:SetVertexColor(temp.r, temp.g, temp.b)
		end
	end
end
ebar[1]:RegisterEvent("RUNE_POWER_UPDATE")
ebar[1]:RegisterEvent("RUNE_TYPE_UPDATE")



else

ebar[6]:Hide()
extraOnEvent = function(self, event, unit)
	temp = GetComboPoints(unit or "player")
	for i=1, 5 do
		if i>temp then
			fadeOut(ebar[i])
		elseif not ebar[i]:IsShown() then
			ebar[i]:SetScale(1.5)
			fadeIn(ebar[i])
			tinsert(scaleframes, ebar[i])
			ebar[i]:Show()
		end
	end
end
ebar[1]:RegisterEvent("PLAYER_TARGET_CHANGED")
ebar[1]:RegisterEvent("UNIT_COMBO_POINTS")
end
ebar[1]:RegisterEvent("PLAYER_ENTERING_WORLD")
ebar[1]:SetScript("OnEvent", extraOnEvent)

-------------------------------------------------------------
--fontstrings
-------------------------------------------------------------
local totname = fontframe:CreateFontString(nil,"OVERLAY")
totname:SetFont("Fonts\\ARIALN.TTF", 13, "OUTLINE")
totname:SetPoint("LEFT", fontframe, "CENTER", 120, 100)
--totname:SetText("Mickelus")
totname:SetJustifyV("LEFT")
local function updatetotname(_,_,unit)
	if unit ~= targetHealth.unit then return end
	if UnitExists(targetHealth.unit.."-target") then
		totname:SetText(UnitName(targetHealth.unit.."-target"))
	else
		totname:SetText(nil)
	end
end
targetHealth[2]:SetScript("OnEvent", updatetotname)
targetHealth[2]:RegisterEvent("UNIT_TARGET")

local castname = fontframe:CreateFontString(nil,"OVERLAY")
castname:SetFont("Fonts\\ARIALN.TTF", 13, "OUTLINE")
castname:SetPoint("RIGHT", fontframe, "CENTER", -120, -100)
--castname:SetText("Heartstone")
castname:SetJustifyV("RIGHT")

local casttime = fontframe:CreateFontString(nil,"OVERLAY")
casttime:SetFont("Fonts\\ARIALN.TTF", 13, "OUTLINE")
casttime:SetPoint("RIGHT", fontframe, "CENTER", 120, 0)
--casttime:SetText(9)
casttime:SetJustifyV("RIGHT")

--[[local aggrotime = fontframe:CreateFontString(nil,"OVERLAY")
aggrotime:SetFont("Fonts\\ARIALN.TTF", 13, "OUTLINE")
aggrotime:SetPoint("LEFT", fontframe, "CENTER", -120, 0)
aggrotime:SetText(12)
aggrotime:SetJustifyV("LEFT")]]

local targetname = fontframe:CreateFontString(nil,"OVERLAY")
targetname:SetFont("Fonts\\ARIALN.TTF", 13, "OUTLINE")
targetname:SetPoint("RIGHT", fontframe, "CENTER", -80, 140)
--targetname:SetText("Mickelus")
targetname:SetJustifyV("RIGHT")
local function updatetargetname(_,_,unit)
	if unit and unit ~= targetHealth.unit then return end
	if UnitExists(targetHealth.unit) then
		
		targetname:SetText(UnitName(targetHealth.unit))
	else
		targetname:SetText(nil)
	end
	if UnitExists(targetHealth.unit.."-target") then
		totname:SetText(UnitName(targetHealth.unit.."-target"))
	else
		totname:SetText(nil)
	end
end
targetHealth[1]:SetScript("OnEvent", updatetargetname)
targetHealth[1]:RegisterEvent("UNIT_NAME_UPDATE")
targetHealth[1]:RegisterEvent("PLAYER_TARGET_CHANGED")

playerPower.text = fontframe:CreateFontString(nil,"OVERLAY")
playerPower.text:SetFont("Fonts\\ARIALN.TTF", 14, "OUTLINE")
playerPower.text:SetPoint("RIGHT", fontframe,"CENTER", 95, -80)
playerPower.text:SetJustifyV("LEFT") 

playerHealth.text = fontframe:CreateFontString(nil,"OVERLAY")
playerHealth.text:SetFont("Fonts\\ARIALN.TTF", 14, "OUTLINE")
playerHealth.text:SetPoint("LEFT", fontframe,"CENTER", -95, -80)
--playerHealth.text:SetText("9001")
playerHealth.text:SetJustifyV("LEFT") 

targetHealth.text = fontframe:CreateFontString(nil,"OVERLAY")
targetHealth.text:SetFont("Fonts\\ARIALN.TTF", 14, "OUTLINE")
targetHealth.text:SetPoint("LEFT", fontframe,"CENTER", 80, 140)
targetHealth.text:SetText("9001")
targetHealth.text:SetJustifyV("LEFT")

-------------------------------------------------------------
--statusbars
-------------------------------------------------------------

local function buffEvent(self, event, unit)
	if unit and unit ~= self.tar then return end
	local dur, expi = select(6, UnitBuff(self.tar, self.aura, nil, (self.pc and "|PLAYER")))
	if not dur then
		dur, expi = select(6, UnitDebuff(self.tar, self.aura, nil, (self.pc and "PLAYER")))
	end
	--print(dur or "nil")
	if dur then
		if self.inv then
			self:SetMinMaxValues(0, dur)
			self.rem = dur-(expi-GetTime())
			self:SetValue(self.rem)
			self:SetScript("OnUpdate", function(self, e)
				self.rem = self.rem + e
				self:SetValue(self.rem)
			end)
		else
			self:SetMinMaxValues(0, dur)
			self.rem = expi-GetTime()
			self:SetValue(self.rem)
			self:SetScript("OnUpdate", function(self, e)
				self.rem = self.rem - e
				self:SetValue(self.rem)
			end)
		end
	else
		self:SetScript("OnUpdate", nil)
		self:SetValue(0)
	end
end

local botbar = CreateFrame("Frame", nil, parent)
botbar.texture = botbar:CreateTexture(nil, "BACKGROUND")
botbar:SetSize(146, 71)
botbar.texture:SetSize(146, 71)
botbar:SetPoint("CENTER", 0,-132.5)
botbar.texture:SetPoint("LEFT")
botbar.texture:SetTexture("Interface\\AddOns\\hud\\botbar.tga")
botbar.max=1
botbar.SetMinMaxValues = function(self, min, max)
	self.max=max
end
botbar.SetValue = function(self, val)
	if val==0 then return end
	if val/self.max >= 1 then
		self.texture:SetWidth(146)
		--print("lololooooo")
	else
		self.texture:SetWidth((val/self.max)*146)
		--print((val or "nil")..", "..(self.max or "nil"))
	end
	
	if self.inv then
		self.texture:SetTexCoord(0, val/self.max, 0, 1)
	else
		self.texture:SetTexCoord( math.abs(val/self.max - 1),1,0,1)
	end

end
botbar.SetStatusBarColor = function(self, ...)
	botbar.texture:SetVertexColor(...)
end
botbar:SetScript("OnEvent", buffEvent)
--[[
local botbar = CreateFrame("StatusBar", nil, parent)
Dimension(botbar, 146, 71)
botbar.texture = botbar:CreateTexture(nil, "BACKGROUND")
Dimension(botbar.texture, 146, 71)
botbar.texture:SetPoint("LEFT", botbar)
botbar:SetPoint("CENTER", 0,-133)
botbar.texture:SetTexture("Interface\\AddOns\\hud\\botbar.tga")
--botbar:SetStatusBarTexture(botbar.texture)
botbar:SetScript("OnEvent", buffEvent)
]]

local leftbar = CreateFrame("Frame", nil, parent)
leftbar.texture = leftbar:CreateTexture(nil, "BACKGROUND")
Dimension(leftbar, 36, 146)
Dimension(leftbar.texture, 36, 146)
leftbar:SetPoint("CENTER", -138,0)
leftbar.texture:SetPoint("BOTTOM")
leftbar.texture:SetTexture("Interface\\AddOns\\hud\\leftbar.tga")
leftbar.max=1
leftbar.SetMinMaxValues = function(self, min, max)
	self.max=max
end
leftbar.SetValue = function(self, val)
	if val==0 then return end
	if val/self.max >= 1 then
		self.texture:SetHeight(146)
		--print("lololooooo")
	else
		self.texture:SetHeight((val/self.max)*146)
		--print((val or "nil")..", "..(self.max or "nil"))
	end
	
	if self.inv then
		self.texture:SetTexCoord(0, 1, 0, val/self.max)
	else
		self.texture:SetTexCoord(0,1,  math.abs(val/self.max - 1),1)
	end

end
leftbar.SetStatusBarColor = function(self, ...)
	leftbar.texture:SetVertexColor(...)
end
leftbar:SetScript("OnEvent", buffEvent)

local rightbar = CreateFrame("Frame", nil, parent)
rightbar.texture = rightbar:CreateTexture(nil, "BACKGROUND")
Dimension(rightbar, 36, 146)
Dimension(rightbar.texture, 36, 146)
rightbar:SetPoint("CENTER", 138,0)
rightbar.texture:SetPoint("BOTTOM")
rightbar.texture:SetTexture("Interface\\AddOns\\hud\\rightbar.tga")
rightbar.max=1
rightbar.SetMinMaxValues = function(self, min, max)
	self.max=max
end
rightbar.SetValue = function(self, val)
	if val==0 then return end
	if val/self.max >= 1 then
		self.texture:SetHeight(146)
		--print("lololooooo")
	else
		self.texture:SetHeight((val/self.max)*146)
		--print((val or "nil")..", "..(self.max or "nil"))
	end
	
	if self.inv then
		self.texture:SetTexCoord(0, 1, 0, val/self.max)
	else
		self.texture:SetTexCoord(0,1,  math.abs(val/self.max - 1),1)
	end

end
rightbar.SetStatusBarColor = function(self, ...)
	rightbar.texture:SetVertexColor(...)
end
rightbar:SetScript("OnEvent", buffEvent)



topbar.texture = topbar:CreateTexture(nil, "BACKGROUND")
topbar:SetSize(218, 54)
topbar.texture:SetSize(218, 54)
topbar:SetPoint("CENTER", -0.5,129)
topbar.texture:SetPoint("LEFT")
topbar.texture:SetTexture("Interface\\AddOns\\hud\\topbar.tga")
topbar.max=1
topbar.SetMinMaxValues = function(self, min, max)
	self.max=max
end
topbar.SetValue = function(self, val)
	if val==0 then return end
	if val/self.max >= 1 then
		self.texture:SetWidth(218)
		self.texture:SetTexCoord(0, 1, 0, 1)
		--print("lololooooo")
	else
		self.texture:SetWidth((val/self.max)*218)
		self.texture:SetTexCoord(0, val/self.max, 0, 1)
		--print((val or "nil")..", "..(self.max or "nil"))
	end
	
	--if self.inv then
		
	--else
		--self.texture:SetTexCoord( math.abs(val/self.max - 1),1,0,1)
	--omgogmoOGMOGMOMGOMGOMGOMGOMGOMG

end
topbar.SetStatusBarColor = function(self, ...)
	topbar.texture:SetVertexColor(...)
end
topbar:SetScript("OnEvent", buffEvent)

--[[Dimension(topbar, 218, 54)
topbar:SetPoint("CENTER", -0.5,129)
topbar:SetStatusBarTexture("Interface\\AddOns\\hud\\topbar.tga")
--topbar:SetStatusBarColor(1, 1, 1, 0.9)
topbar:SetAlpha(0.6)]]
topbar:SetScript("OnEvent", function(self, event, unit)
	if (UnitExists(targetHealth.unit) and UnitPowerMax(targetHealth.unit)>0) then self:Show()  else self:Hide() return end
	if event == "UNIT_MAXMANA" or event == "PLAYER_TARGET_CHANGED" or event == "UNIT_MAXRUNIC_POWER" or event == "UNIT_MAXRAGE" or event == "UNIT_MAXENERGY" then
		self:SetMinMaxValues(0, UnitPowerMax(targetHealth.unit))
	end
	self:SetValue(UnitPower(targetHealth.unit))

end)
topbar:RegisterEvent("UNIT_MANA")
topbar:RegisterEvent("UNIT_MAXMANA")
topbar:RegisterEvent("UNIT_ENERGY")
topbar:RegisterEvent("UNIT_MAXENERGY")
topbar:RegisterEvent("UNIT_RAGE")
topbar:RegisterEvent("UNIT_MAXRAGE")
topbar:RegisterEvent("UNIT_RUNIC_POWER")
topbar:RegisterEvent("UNIT_MAXRUNIC_POWER")
topbar:RegisterEvent("PLAYER_TARGET_CHANGED")

local range = {}
range[1] = parent:CreateTexture(nil, "BACKGROUND")
Dimension(range[1])
range[1]:SetPoint("CENTER",0,0)
range[1]:SetTexture("Interface\\AddOns\\hud\\range.tga")
range[1].rotation = -19
RT(range[1], range[1].rotation)
range[1]:SetAlpha(0.5)

range[2] = parent:CreateTexture(nil, "BACKGROUND")
Dimension(range[2])
range[2]:SetPoint("CENTER",0,0)
range[2]:SetTexture("Interface\\AddOns\\hud\\range.tga")
range[2].rotation = 0.25
RT(range[2], range[2].rotation)
range[2]:SetAlpha(0.5)

range[3] = parent:CreateTexture(nil, "BACKGROUND")
Dimension(range[3])
range[3]:SetPoint("CENTER",0,0)
range[3]:SetTexture("Interface\\AddOns\\hud\\range.tga")
range[3].rotation = 19.5
RT(range[3], range[3].rotation)
range[3]:SetAlpha(0.5)

local rangeframe=CreateFrame("Frame")
local rangetemp
rangeframe:SetScript("OnUpdate", function(_, e)
for i=1, 3 do
	if range[i].spell then
		rangetemp = IsSpellInRange(range[i].spell, range[i].unit)
		if rangetemp and rangetemp==1 then
			range[i]:SetAlpha(range[i].aa)
			range[i]:SetVertexColor(unpack(range[i].ac))
		else
			range[i]:SetAlpha(range[i].ia)
			range[i]:SetVertexColor(unpack(range[i].ic))
		end
	end
end
end)

local distl = parent:CreateTexture(nil, "BACKGROUND")
Dimension(distl)
distl:SetPoint("CENTER",0,0)
distl:SetTexture("Interface\\AddOns\\hud\\dist.tga")
RT(distl, -0.5)
distl:SetAlpha(0.2)

local distr = parent:CreateTexture(nil, "BACKGROUND")
Dimension(distr)
distr:SetPoint("CENTER",0,0)
distr:SetTexture("Interface\\AddOns\\hud\\dist.tga")
RT(distr, -106.7)
distr:SetAlpha(0.2)

local ring = frame:CreateTexture(nil, "BACKGROUND")
Dimension(ring)
ring:SetPoint("CENTER",0,0)
ring:SetTexture("Interface\\AddOns\\hud\\ring.tga")
ring:SetAlpha(0.5)

local bling = frame:CreateTexture(nil, "BACKGROUND")
Dimension(bling)
bling:SetPoint("CENTER",0,0)
bling:SetTexture("Interface\\AddOns\\hud\\bling.tga")
bling:SetAlpha(0.5)

local aggro = {};
aggro[1] = frame:CreateTexture(nil, "BACKGROUND")
Dimension(aggro[1])
aggro[1]:SetPoint("CENTER",0,-0.5)
aggro[1]:SetTexture("Interface\\AddOns\\hud\\aggro1.tga")
aggro[1].rotation = 0
RT(aggro[1], aggro[1].rotation)

aggro[2] = frame:CreateTexture(nil, "BACKGROUND")
Dimension(aggro[2])
aggro[2]:SetPoint("CENTER",0,-0.5)
aggro[2]:SetTexture("Interface\\AddOns\\hud\\aggro2.tga")
aggro[2].rotation = 0;
RT(aggro[2], aggro[2].rotation)
aggro[1]:Hide()

aggro[3] = frame:CreateTexture(nil, "BACKGROUND")
Dimension(aggro[3])
aggro[3]:SetPoint("CENTER",0,-0.5)
aggro[3]:SetTexture("Interface\\AddOns\\hud\\aggro3.tga")
aggro[3].rotation = 0;
RT(aggro[3], aggro[3].rotation)
aggro[2]:Hide()

local ca_ev = {
"UNIT_SPELLCAST_CHANNEL_START",
"UNIT_SPELLCAST_CHANNEL_STOP",
"UNIT_SPELLCAST_CHANNEL_UPDATE",
"UNIT_SPELLCAST_DELAYED",
--"UNIT_SPELLCAST_FAILED",
--"UNIT_SPELLCAST_FAILED_QUIET",
--"UNIT_SPELLCAST_INTERRUPTED",
"UNIT_SPELLCAST_START",
"UNIT_SPELLCAST_STOP",
--"UNIT_SPELLCAST_SUCCEEDED",
}
local castprog, castend, casttext, caststart = 1, 0

local sweep
local timer = 0
frame.i = 1
local arot = 0
local crot = 20
local frad = 1
local function frameEvent(self, event, unit)
	if unit and unit~=playerHealth.unit then return end
	if event == "UNIT_SPELLCAST_START" or event == "UNIT_SPELLCAST_CHANNEL_START" then
		fadeIn(frame)
	elseif event == "UNIT_SPELLCAST_STOP" or event == "UNIT_SPELLCAST_CHANNEL_STOP" then
		fadeOut(frame)
	end
	if event == "UNIT_SPELLCAST_CHANNEL_START" or event == "UNIT_SPELLCAST_CHANNEL_STOP" or event == "UNIT_SPELLCAST_CHANNEL_UPDATE" then
		casttext, _, _, _, caststart, castend = UnitChannelInfo(playerHealth.unit)
	else
		casttext, _, _, _, caststart, castend = UnitCastingInfo(playerHealth.unit)
	end
	castname:SetText(casttext)
	if caststart then caststart = caststart/1000 end
	if castend then castend = castend/1000 end
	castprog=GetTime()
	casttime:SetText(castend and (floor(10*(castend-castprog))/10) or nil)
end
frame:SetScript("OnEvent", frameEvent)
for i=1, #ca_ev do
	frame:RegisterEvent(ca_ev[i])
end
frame:SetScript("OnUpdate", function(self, e)
if castend and castprog<castend then
	castprog=castprog+e
	--arot = arot + e*(20-300*(1-((castend-castprog)/(castend-caststart))))
	if crot>20-300*(1-((castend-castprog)/(castend-caststart))) then
		crot = 20-300*(1-((castend-castprog)/(castend-caststart)))
	end
	casttime:SetText(floor(10*(castend-castprog))/10)
elseif crot<20 then
		crot = crot+e*200
		if (crot+e*200)>20 then crot = 20 end
end
arot = arot + e*crot
if arot>360 then arot = arot%360 end
RT(aggro[3], arot)
if not sweep then return end
timer = timer + e
if timer > 0.05 then
	self.i = self.i + frad
	timer = timer - 0.05
	if self.i < 1 then
		frad = 1
	elseif self.i > 20 or ( not playerHealth[self.i]:IsShown() ) then
		frad = -1
	else
		playerHealth[self.i]:SetAlpha(0)
		fadeIn(playerHealth[self.i])
	end
end
end)

local buff = {}
local debuff = {}

buff[0] = CreateFrame("Frame", nil, parent)
Dimension(buff[0])
buff[0]:SetPoint("CENTER",0,0)

debuff[0] = CreateFrame("Frame", nil, parent)
Dimension(debuff[0])
debuff[0]:SetPoint("CENTER",0,0)
 
 for i=1, 10 do 
	buff[i] = CreateFrame("Frame",nil,buff[0]);
	Dimension(buff[i], 16);
	buff[i]:SetPoint("CENTER", (170+i*0.1)*cos(rad(6*i+140)), (170+i*0.1)*sin(rad(6*i+140)))
	--[[if i == 1 then
		buff[i]:SetPoint("TOPLEFT", targetf, "TOPRIGHT", 4, 0);
	else
		buff[i]:SetPoint("TOPLEFT", buff[i-1], "TOPRIGHT", 1, 0);
	end]]
	buff[i].icon = buff[i]:CreateTexture(nil);
	buff[i].icon:SetPoint("CENTER");
	Dimension(buff[i].icon, 12);
	buff[i].icon:SetTexCoord(0.1, 0.9, 0.1, 0.9);
	buff[i].icon:SetTexture("Interface\\ICONS\\Ability_Ambush");
	buff[i].border1 = buff[i]:CreateTexture(nil, "BACKGROUND");
	buff[i].border1:SetAllPoints(buff[i]);
	buff[i].border1:SetTexture(0,0,0);
	buff[i].border2 = buff[i]:CreateTexture(nil, "BORDER");
	buff[i].border2:SetPoint("TOPLEFT", buff[i], 1, -1);
	buff[i].border2:SetPoint("BOTTOMRIGHT", buff[i], -1, 1);
	buff[i].border2:SetTexture(0.5,0.5,0.5);
	buff[i].duration = CreateFrame("Cooldown",nil,buff[i]);
	buff[i].duration:SetAllPoints(buff[i]);
	buff[i].duration:SetReverse(true);
	
	
	buff[i].id = i;
	buff[i]:EnableMouse(true);
	buff[i]:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT", -30, 15);
		GameTooltip:SetUnitBuff("target", self.id);
		GameTooltip:Show();
		self:SetScript("OnUpdate", function(self)
			GameTooltip:SetUnitBuff("target", self.id);
		end);
	end);
	buff[i]:SetScript("OnLeave", function(self)
		GameTooltip:Hide();
		self:SetScript("OnUpdate", nil);
	end);
	--buff[i]:Hide();
	
	debuff[i] = CreateFrame("Frame",nil,debuff[0]);
	Dimension(debuff[i], 16);
	debuff[i]:SetPoint("CENTER", (190+i*0.1)*cos(rad(6*i+140)), (190+i*0.1)*sin(rad(6*i+140)))
	--[[if i == 1 then
		debuff[i]:SetPoint("TOPLEFT", targetf, "TOPRIGHT", 4, -18);
	else
		debuff[i]:SetPoint("TOPLEFT", debuff[i-1], "TOPRIGHT", 1, 0);
	end]]
	debuff[i].icon = debuff[i]:CreateTexture(nil);
	debuff[i].icon:SetPoint("CENTER");
	Dimension(debuff[i].icon, 12);
	debuff[i].icon:SetTexCoord(0.1, 0.9, 0.1, 0.9);
	debuff[i].icon:SetTexture("Interface\\ICONS\\Ability_Ambush");
	debuff[i].border1 = debuff[i]:CreateTexture(nil, "BACKGROUND");
	debuff[i].border1:SetAllPoints(debuff[i]);
	debuff[i].border1:SetTexture(0,0,0);
	debuff[i].border2 = debuff[i]:CreateTexture(nil, "BORDER");
	debuff[i].border2:SetPoint("TOPLEFT", debuff[i], 1, -1);
	debuff[i].border2:SetPoint("BOTTOMRIGHT", debuff[i], -1, 1);
	debuff[i].border2:SetTexture(0.5,0.5,0.5);
	debuff[i].duration = CreateFrame("Cooldown",nil,debuff[i]);
	debuff[i].duration:SetAllPoints(debuff[i]);
	debuff[i].duration:SetReverse(true);
	
	
	debuff[i].id = i;
	debuff[i]:EnableMouse(true);
	debuff[i]:SetScript("OnEnter", function(self)
		GameTooltip:SetOwner(self, "ANCHOR_BOTTOMRIGHT", 15, -25);
		GameTooltip:SetUnitDebuff("target", self.id);
		GameTooltip:Show();
		self:SetScript("OnUpdate", function(self)
			GameTooltip:SetUnitDebuff("target", self.id);
		end);
	end);
	debuff[i]:SetScript("OnLeave", function(self)
		GameTooltip:Hide();
		self:SetScript("OnUpdate", nil);
	end);
	--debuff[i]:Hide();
 end

local function updateaura(_,_, unit)
if unit and unit ~= targetHealth.unit then return end
	for i=1, 10 do 
		name, rank, icon, count, debuffType, duration, expirationTime = UnitBuff(targetHealth.unit, i);
		if icon then
			buff[i]:Show();
			buff[i].icon:SetTexture(icon);
			if ( duration ) then
				buff[i].duration:Show();
				CooldownFrame_SetTimer(buff[i].duration, expirationTime - duration, duration, 1);
			else
				buff[i].duration:Hide();
			end
		else
			buff[i]:Hide();
		end
		name, rank, icon, count, debuffType, duration, expirationTime = UnitDebuff(targetHealth.unit, i);
		if icon then
			debuff[i]:Show();
			debuff[i].icon:SetTexture(icon);
			if ( duration ) then
				debuff[i].duration:Show();
				CooldownFrame_SetTimer(debuff[i].duration, expirationTime - duration, duration, 1);
			else
				debuff[i].duration:Hide();
			end
		else
			debuff[i]:Hide();
		end
	end

end

buff[0]:SetScript("OnEvent", updateaura)
buff[0]:RegisterEvent("UNIT_AURA")
buff[0]:RegisterEvent("PLAYER_ENTERING_WORLD")
buff[0]:RegisterEvent("PLAYER_TARGET_CHANGED")

TargetFrame:Hide()
TargetFrame:UnregisterAllEvents()
TargetFrame.Show = function() end
 
 PlayerFrame:Hide()
 PlayerFrame:UnregisterAllEvents()
 PlayerFrame.Show = function() end
 
 playerInteract = CreateFrame("Button", nil, UIParent, "SecureActionButtonTemplate")
 playerInteract:SetPoint("TOPLEFT")
 Dimension(playerInteract, 2)
 playerInteract:RegisterForClicks("AnyUp")
 temp=function() ToggleDropDownMenu(1, nil, PlayerFrameDropDown, "playerInteract", 0, 0) end
 SecureUnitButton_OnLoad(playerInteract, "player", temp)

	
 targetInteract = CreateFrame("Button", nil, UIParent, "SecureActionButtonTemplate")
 targetInteract:SetPoint("TOPRIGHT")
 Dimension(targetInteract, 2)
 targetInteract:RegisterForClicks("AnyUp")
 SecureUnitButton_OnLoad(targetInteract, "player", function()
		ToggleDropDownMenu(1, nil, TargetFrameDropDown, "targetInteract", 0, 0);
	end)
 
 
 RuneFrame:Hide();
RuneFrame.Show = function() end
RuneFrame:UnregisterAllEvents()

local function slashhud(cmd)
	if IsAddOnLoaded("hud config") then
		if hudconfigframe:IsShown() then
			fadeOut(hudconfigframe)
			parent:SetFrameStrata("LOW")
			if not fadehpf and not fadempf and not fadempe and not fadenc and not fadent then
				fadeframe:SetScript("OnEvent", nil)
			else
				fadeframe:SetScript("OnEvent", fadefunc)
				fadefunc(fadeframe)
			end
		else
			fadeframe:SetScript("OnEvent", nil)
			fadeframe:Show()
			fadeIn(fadeframe)
			hudconfigframe:Show()
			fadeIn(hudconfigframe)
			parent:SetFrameStrata("TOOLTIP")
		end
	else
		temp = select(2,LoadAddOn("hud config"))
		if temp then
			ChatFrame1:AddMessage("Could not load hud config, reason: "..temp)
		else
			fadeframe:Show()
			fadeIn(fadeframe)
			fadeframe:SetScript("OnEvent", nil)
			fadeIn(hudconfigframe)
			parent:SetFrameStrata("TOOLTIP")
		end
	end
end



SLASH_HUD1 = "/hud"
SlashCmdList["HUD"] = slashhud

function updateHud()
	if type(hudoptions[hudpro].botbar[1]) == "string" then
		hudoptions = hudwipetable
		hudpro="default"
		print("Hud variables whiped")
	end
	if not hudoptions[hudpro].buff then
		hudoptions = hudwipetable
		hudpro="default"
		print("Hud variables whiped")
	end
	if not hudoptions[hudpro].target then
		hudoptions = hudwipetable
		hudpro="default"
		print("Hud variables whiped")
	end
	if not hudoptions[hudpro].target[10] then
		hudoptions = hudwipetable
		hudpro="default"
		print("Hud variables whiped")
	end
	playerHealth:SetAlpha(hudoptions[hudpro].health[1])
	playerHealth.textStyle = hudoptions[hudpro].health[10]
	playerHealth.hideFull = hudoptions[hudpro].health[11]
	if hudoptions[hudpro].health[9] then
		playerHealth.text:Show()
	else
		playerHealth.text:Hide()
	end
	playerHealth:UpdateText(UnitHealth(playerHealth.unit), UnitHealthMax(playerHealth.unit))
	playerPower:SetAlpha(hudoptions[hudpro].power[1])
	playerPower.textStyle = hudoptions[hudpro].power[10]
	playerPower.hideFull = hudoptions[hudpro].power[11]
	playerPower.hideEmpty = hudoptions[hudpro].power[12]
	playerPower:UpdateText(UnitPower(playerHealth.unit), UnitPowerMax(playerHealth.unit))
	for i=1, 20 do
		playerHealth[i].texture:SetVertexColor(unpack(hudoptions[hudpro].health[2]))
		playerPower[i].texture:SetVertexColor(unpack(hudoptions[hudpro].power[2]))
	end
	parent:SetScale(hudoptions[hudpro].general[1])
	parent:SetAlpha(hudoptions[hudpro].general[2])
	parent:SetPoint("CENTER",hudoptions[hudpro].general[3],hudoptions[hudpro].general[4])
	sweep = hudoptions[hudpro].health[12]
	if hudoptions[hudpro].botbar[1] then
		botbar.aura = hudoptions[hudpro].botbar[2]
		botbar.tar = hudoptions[hudpro].botbar[3]
		if botbar.tar == "target" then
			botbar:RegisterEvent("PLAYER_TARGET_CHANGED")
		end
		botbar:SetStatusBarColor(unpack(hudoptions[hudpro].botbar[4]))
		botbar:SetAlpha(hudoptions[hudpro].botbar[5])
		botbar.inv = hudoptions[hudpro].botbar[6]
		botbar.texture:ClearAllPoints()
		if botbar.inv then
			botbar.texture:SetPoint("LEFT")
		else
			botbar.texture:SetPoint("RIGHT")
		end
		botbar.pc = hudoptions[hudpro].botbar[7]
		botbar:RegisterEvent("UNIT_AURA")
	else
		botbar:UnRegisterAllEvents()
		botbar:SetValue(0)
	end
	if hudoptions[hudpro].leftbar[1] then
		leftbar.aura = hudoptions[hudpro].leftbar[2]
		leftbar.tar = hudoptions[hudpro].leftbar[3]
		if leftbar.tar == "target" then
			leftbar:RegisterEvent("PLAYER_TARGET_CHANGED")
		end
		leftbar:SetStatusBarColor(unpack(hudoptions[hudpro].leftbar[4]))
		leftbar:SetAlpha(hudoptions[hudpro].botbar[5])
		leftbar.inv = hudoptions[hudpro].leftbar[6]
		leftbar.texture:ClearAllPoints()
		if leftbar.inv then
			leftbar.texture:SetPoint("TOP")
		else
			leftbar.texture:SetPoint("BOTTOM")
		end
		leftbar.pc = hudoptions[hudpro].leftbar[7]
		leftbar:RegisterEvent("UNIT_AURA")
	else
		leftbar:UnregisterAllEvents()
	end
	
	if hudoptions[hudpro].rightbar[1] then
		rightbar.aura = hudoptions[hudpro].rightbar[2]
		rightbar.tar = hudoptions[hudpro].rightbar[3]
		if rightbar.tar == "target" then
			rightbar:RegisterEvent("PLAYER_TARGET_CHANGED")
		end
		rightbar:SetStatusBarColor(unpack(hudoptions[hudpro].rightbar[4]))
		rightbar:SetAlpha(hudoptions[hudpro].botbar[5])
		rightbar.inv = hudoptions[hudpro].rightbar[6]
		rightbar.texture:ClearAllPoints()
		if rightbar.inv then
			rightbar.texture:SetPoint("TOP")
		else
			rightbar.texture:SetPoint("BOTTOM")
		end
		rightbar.pc = hudoptions[hudpro].rightbar[7]
		rightbar:RegisterEvent("UNIT_AURA")
	else
		rightbar:UnregisterAllEvents()
	end
	
	--[[if hudoptions[hudpro].rightbar[1] then
		rightbar.aura = hudoptions[hudpro].rightbar[2]
		rightbar.tar = hudoptions[hudpro].rightbar[3]
		if rightbar.tar == "target" then
			rightbar:RegisterEvent("PLAYER_TARGET_CHANGED")
		end
		rightbar:SetStatusBarColor(unpack(hudoptions[hudpro].rightbar[4]))
		rightbar:SetAlpha(hudoptions[hudpro].botbar[5])
		rightbar.inv = hudoptions[hudpro].rightbar[6]
		rightbar.pc = hudoptions[hudpro].rightbar[7]
		if rightbar.inv then
			rightbar.texture:SetPoint("TOP")
		else
			rightbar.texture:SetPoint("BOTTOM")
		end
		rightbar:RegisterEvent("UNIT_AURA")
	else
		rightbar:UnRegisterAllEvents()
	end]]
	if hudoptions[hudpro].botblock[1] and hudoptions[hudpro].botblock[1]~="" then
		range[1].spell = hudoptions[hudpro].botblock[1]
		range[1].unit = hudoptions[hudpro].botblock[2]
		range[1].ac = hudoptions[hudpro].botblock[3]
		range[1].aa = hudoptions[hudpro].botblock[4]
		range[1].ic = hudoptions[hudpro].botblock[5]
		range[1].ia = hudoptions[hudpro].botblock[6]
	else
		range[1].spell=nil
	end
	if hudoptions[hudpro].botblock[7] and hudoptions[hudpro].botblock[7]~="" then
		range[2].spell = hudoptions[hudpro].botblock[7]
		range[2].unit = hudoptions[hudpro].botblock[8]
		range[2].ac = hudoptions[hudpro].botblock[9]
		range[2].aa = hudoptions[hudpro].botblock[10]
		range[2].ic = hudoptions[hudpro].botblock[11]
		range[2].ia = hudoptions[hudpro].botblock[12]
	else
		range[2].spell=nil
	end
	if hudoptions[hudpro].botblock[13] and hudoptions[hudpro].botblock[13]~="" then
		range[3].spell = hudoptions[hudpro].botblock[13]
		range[3].unit = hudoptions[hudpro].botblock[14]
		range[3].ac = hudoptions[hudpro].botblock[15]
		range[3].aa = hudoptions[hudpro].botblock[16]
		range[3].ic = hudoptions[hudpro].botblock[17]
		range[3].ia = hudoptions[hudpro].botblock[18]
	else
		range[3].spell=nil
	end
	if hudoptions[hudpro].buff[1] then
		buff[0]:Show()
	else
		buff[0]:Hide()
	end
	if hudoptions[hudpro].buff[2] then
		debuff[0]:Show()
	else
		debuff[0]:Hide()
	end
	updateaura(nil, nil, targetHealth.unit)
	buff[0]:RegisterEvent("UNIT_AURA")
	buff[0]:RegisterEvent("PLAYER_ENTERING_WORLD")
	buff[0]:RegisterEvent("PLAYER_TARGET_CHANGED")
	if not ( hudoptions[hudpro].buff[1] and hudoptions[hudpro].buff[2] ) then
		buff[0]:UnregisterAllEvents()
	end
	temp=hudoptions[hudpro].general
	fadeframe:UnregisterAllEvents()
	fadeframe:RegisterEvent("PLAYER_ENTERING_WORLD")
	fadehpf, fadempf, fadempe, fadenc, fadent = temp[5], temp[6], temp[7], temp[8], temp[9]
	if temp[5] then
		fadeframe:RegisterEvent("UNIT_HEALTH")
	end
	if temp[6] or temp[7] then
		fadeframe:RegisterEvent("UNIT_MANA")
		fadeframe:RegisterEvent("UNIT_MAXMANA")
		fadeframe:RegisterEvent("UNIT_ENERGY")
		fadeframe:RegisterEvent("UNIT_MAXENERGY")
		fadeframe:RegisterEvent("UNIT_RAGE")
		fadeframe:RegisterEvent("UNIT_MAXRAGE")
		fadeframe:RegisterEvent("UNIT_RUNIC_POWER")
		fadeframe:RegisterEvent("UNIT_MAXRUNIC_POWER")
	end
	if temp[8] then
		fadeframe:RegisterEvent("PLAYER_REGEN_ENABLED")
		fadeframe:RegisterEvent("PLAYER_REGEN_DISABLED")
	end
	if temp[9] then
		fadeframe:RegisterEvent("PLAYER_TARGET_CHANGED")
	end
	temp=hudoptions[hudpro].target
	targetHealth:SetAlpha(temp[1])
	topbar:SetAlpha(temp[5])
	coltarhp, clatarhp, hostarhp, coltarpp, clatarpp, powtarpp = temp[2], temp[3], temp[4], temp[6], temp[7], temp[8]
	targetHealth.textStyle = hudoptions[hudpro].target[10]
	targetHealth.hideFull = hudoptions[hudpro].target[11]
	targetHealth.hideEmpty = hudoptions[hudpro].target[12]
	if hudoptions[hudpro].target[9] then
		targetHealth.text:Show()
	else
		targetHealth.text:Hide()
	end
	targetHealth:PLAYER_TARGET_CHANGED()
end
parent:SetScript("OnEvent", function()
	updateHud()
	if not fadehpf and not fadempf and not fadempe and not fadenc and not fadent then
		fadeframe:SetScript("OnEvent", nil)
	else
		fadeframe:SetScript("OnEvent", fadefunc)
		fadefunc(fadeframe)
	end
end)
parent:RegisterEvent("VARIABLES_LOADED")
